#ifndef __GMLMIP_ONESTEP_H_
#define __GMLMIP_ONESTEP_H_

#include <vector>
#include <set>
#include <utility> // for pair
#include "formulas/formula.h"


/* transforms list of gml formulas (diamond?,number,formula)
   to list of consequences (formula,positive?),
   here positive? means that the formula must be true in order to make the
   given conjunct of modalities true
*/
typedef std::vector<std::pair<std::pair<bool,int>,int> > GMLPremise;
/*
 * For PML, the premise is a list of modal formulas:
 *      ((diamond?,(nominator,denominator)),formula)
 */
typedef std::vector<std::pair<std::pair<bool,std::pair<int,int> >,int> > PMLPremise;
/*
 * The Conclusion is the same for PML and GML:
 * It is a set of rule conclusions. One rule conclusions is of the form \/ /\ lit
 * where lit is encoded by: (formula,positive?)
 */
typedef std::set<std::set<std::set<int> > > GMLConclusion;

GMLConclusion gmlmip_onestep_gml(GMLPremise modvec);
GMLConclusion gmlmip_onestep_pml(PMLPremise modvec);

void printRuleCollection(const RuleCollection& rc);

#endif
