
external set_readline_name : string -> unit = "set_readline_name"
external readline : unit -> string option = "readline_stub"
external readline_prompt : string -> string option = "readline_prompt_stub"
external add_history  : string -> unit = "add_history_stub"
external connect_to_curses : unit -> unit = "connect_to_curses"
external line_buffer : unit -> string = "line_buffer_stub"
external wrong_cursor_position : unit -> int = "cursor_position_stub"


let do_nothing = fun () -> ()

let redraw_callback = ref (do_nothing)

let call_callback () : unit = (!redraw_callback) ()

let _ =
    Callback.register "readline_redraw_callback" call_callback;

external readline_use_ocaml_callback : unit -> unit = "readline_use_ocaml_callback"

let register_redraw cb =
    redraw_callback := cb;
    readline_use_ocaml_callback()

let utf8length str =
    let count = ref (0) in
    let check ch =
        if (((Char.code ch) land 0xc0) <> 0x80)
        then count := !count + 1
    in
    String.iter check str;
    !count

let readline_state () =
    let wrong_cursor = wrong_cursor_position () in
    let line = line_buffer () in
    line, utf8length (String.sub line 0 wrong_cursor)
